*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 * Based on ADORDD samples included in Harbour distribution
*/
*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

#include "hmg.ch"
#include "adordd.ch"
#include "hfcl.ch"
#include "adordd.prg"
#include "apoyo.prg"
#include "mIBox.prg"
#include "mPrint.prg"

  REQUEST ADORDD

  Function Main()

  SET CENTURY ON 
  SET DATE FRENCH 
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET EPOCH TO 2000
  SET ESCAPE ON
  SET DELETED oN 
  SET NAVIGATION EXTENDED
  SET BROWSESYNC ON
  SET DECIMALS TO 0

*------------------------------------------------------------------*
  SET TOOLTIPSTYLE BALLOON
// this follow rows is required ONLY for HMG Minigui compatibility
#ifdef __MINGW32__
   SET TOOLTIPBACKCOLOR { 193, 224, 255 } 
   SET TOOLTIPFORECOLOR { 000, 000, 000 }
#endi
*-------------------------------------------------------------------*

*-------------------------------------------------------------------*
  Public aTable, ficher, Xnew_RecNo
*-------------------------------------------------------------------*
  
  IF ! FILE('test2.mdb') 
    CreateNewTable()
  ENDIF

  IF FILE('test2.mdb') 
     copy file("test2.mdb") to ("backup_files\"+"test2.mdb")
  ENDIF

   DEFINE WINDOW Form_1         ;
      AT 0,0                    ;
      WIDTH 900                 ;                     
      HEIGHT 665                ;                       
      TITLE "Base SQLite"       ;
      ICON 'Logo'               ;     
      BACKCOLOR { 150,234,203 } ;
      NOMAXIMIZE NOSYSMENU NOSIZE ; 
      MAIN                      ;
      ON INIT CreateTable()     ;
      ON RELEASE CloseTable()
      ON KEY ESCAPE ACTION FinalProgram()           

*-------------------------------------------------------------------------------------------------------------*
*----------------------  Routine TIMER donated by Lucho Miranda  ElSalnes@telefonica.net ---------------------*
          DEFINE TIMER Timer_1 INTERVAL 1000 ACTION ;        
                    ( Form_1.Title :="DataBase Adordd Photo"+ SPACE(03)+" Date: " + DTOC(DATE()) + ;
                     SPACE(03) + "Time: " + TIME() )                         
*-------------------------------------------------------------------------------------------------------------* 
*-------------------------------------------------------------------------------------------------------------* 

   DEFINE LABEL Label_00
        ROW    020
        COL    300  
        WIDTH  200  
        HEIGHT 030
        VALUE "DataBase Adordd Photo"
        FONTNAME "Arial"
        FONTSIZE 13
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {150,234,203}
        FONTCOLOR NIL
    END LABEL

*-----------------------------------------------------------------*

    DEFINE LABEL Label_11
        ROW    060  
        COL    030
        WIDTH  070
        HEIGHT 020
        VALUE "Code:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {150,234,203}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_11
        ROW    060   
        COL    120
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_11.FontBold := .T.  
        ONLOSTFOCUS Form_1.Label_11.FontBold := .F.  
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 5
        BACKCOLOR {253,209,209}  
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .T. 
        VALUE Nil
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_22
        ROW    090    
        COL    030
        WIDTH  070
        HEIGHT 020
        VALUE "Name:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {150,234,203}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_22
        ROW    090    
        COL    120
        WIDTH  310
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Name"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_22.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_22.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 55
        BACKCOLOR  {253,209,209} 
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_33
        ROW    120    
        COL    030
        WIDTH  070
        HEIGHT 020
        VALUE "Phone:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {150,234,203}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_33
        ROW    120  
        COL    120
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Phone"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_33.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_33.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.    
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 9
        BACKCOLOR { 253,209,209 }  
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .F.                 
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_44
        ROW    150    
        COL    030
        WIDTH  070
        HEIGHT 020
        VALUE "Date:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {150,234,203}
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_44
        ROW    150  
        COL    120
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Date"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_44.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_44.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 10
        BACKCOLOR {253,209,209}  
        FONTCOLOR NIL
        INPUTMASK "99/99/9999"
        FORMAT Nil
        NUMERIC .F.                 
        VALUE DTOC(DATE())
    END TEXTBOX

*-----------------------------------------------------------------*

     DEFINE LABEL Label_55
        ROW    180    
        COL    030
        WIDTH  070
        HEIGHT 020
        VALUE "N Photo:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {150,234,203}
        FONTCOLOR NIL
    END LABEL 

    DEFINE TEXTBOX Text_55
        ROW    180  
        COL    120
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "N Photo"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_55.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_55.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 10
        BACKCOLOR { 253,209,209 }  
        FONTCOLOR NIL
        INPUTMASK "99999" 
        FORMAT Nil
        NUMERIC .F.   
        VALUE ""                     
    END TEXTBOX

*-----------------------------------------------------------------*
 
    DEFINE LABEL Edit11
        ROW    057    
        COL    337 
        WIDTH  070
        HEIGHT 020
        VALUE "Notes:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {150,234,203}
        FONTCOLOR NIL
    END LABEL

    DEFINE EDITBOX Edit_11
        ROW    060
        COL    450
        WIDTH  235 
        HEIGHT 140   
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Notes"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Edit11.FontBold := .T.
        ONLOSTFOCUS Form_1.Edit11.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        HSCROLLBAR .T.
        VSCROLLBAR .T.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        BACKCOLOR  { 253, 209, 209 }    
        FONTCOLOR Nil
    END EDITBOX

    DEFINE LABEL Label_66
        ROW    120
        COL    337
        WIDTH  080
        HEIGHT 020
        VALUE "Married:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {150,234,203}
        FONTCOLOR NIL
    END LABEL 

    DEFINE TEXTBOX Text_66
        ROW    150  
        COL    337
        WIDTH  040
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Married"
        ONCHANGE Nil
        ONGOTFOCUS  Form_1.Label_66.FontBold := .T.
        ONLOSTFOCUS Form_1.Label_66.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 3
        BACKCOLOR { 253,209,209 }  
        FONTCOLOR NIL
        INPUTMASK NIL
        FORMAT Nil
        NUMERIC .F.                 
        VALUE ""
    END TEXTBOX
  

*--------------------------------------------------------------------------------------------------------------------------------*
*--------------------------------------------------------------  Browse ---------------------------------------------------------*
*--------------------------------------------------------------------------------------------------------------------------------*

  
   Private fColor     := { || if ( recno()/2 == int(recno()/2) , { 000,255,020 } , { 015,000,255 } ) }  
   Private bDS_Salmon := { || IIF( This.CellRowIndex / 2 == INT( This.CellRowIndex / 2 ), { 255, 202, 149 } , { 080, 240, 006 } ) } 

   ficher := 'table1'

   aTable := { 'table1->Code' , 'table1->Name' , 'table1->Phone' , 'table1->Date', 'table1->Married', 'table1->Notes' , 'table1->Photo'}  

     DEFINE BROWSE Browse_1
        ROW    240   
        COL    040   
        WIDTH  647             
        HEIGHT 220   
        VALUE 1
        WIDTHS  { 085, 262 , 110 , 115 , 075 , 0 , 0}                   // 0 <------------------- porque asi no sale en Browse
        HEADERS {"Code", "Name", "Phone", "Date", "Married", "", ""}    //"Notes" "" <----------- because that's not in Browse 
        WORKAREA &ficher   
        FIELDS  aTable     
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE ArribAbajo()             
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .T.  
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONDBLCLICK Apoyox_2()        
        ALLOWEDIT .F.
        ALLOWAPPEND .F.    
        ONHEADCLICK Nil
        ALLOWDELETE .F.  
        HELPID Nil
        VALID Nil               
        VALIDMESSAGES Nil
        LOCK .F.
        VSCROLLBAR .F.   
        DYNAMICFORECOLOR { fcolor, fcolor, fcolor, fcolor, fcolor, fcolor, fcolor } 
        DYNAMICBACKCOLOR { bDS_Salmon,bDS_Salmon,bDS_Salmon,bDS_Salmon,bDS_Salmon,bDS_Salmon,bDS_Salmon }
        INPUTMASK Nil
        FORMAT Nil
        WHEN Nil
        INPUTITEMS Nil
        DISPLAYITEMS Nil
        BACKCOLOR { 209,238,238 }
        FONTCOLOR { 000,000,000 }   
        IMAGE Nil
        JUSTIFY { BROWSE_JTFY_RIGHT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT , BROWSE_JTFY_LEFT, BROWSE_JTFY_LEFT } 
        NOLINES .F.
        READONLYFIELDS Nil
        HEADERIMAGES Nil
    END BROWSE
  
*---------------------------------------------------------------------* 
*---------------------------------  Photo  ---------------------------*
*---------------------------------------------------------------------* 
 
    DEFINE EDITBOX EditBoxBio 
        ROW    256  
        COL    708   
        WIDTH  159  
        HEIGHT 194  
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS   Form_1.ImagePhoto.READONLY := .T.  
        ONLOSTFOCUS  Form_1.ImagePhoto.READONLY := .T.  
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.    
        HSCROLLBAR .F.   
        VSCROLLBAR .F.  
        BACKCOLOR Nil
        FONTCOLOR Nil
    END EDITBOX
	
    DEFINE IMAGE ImagePhoto  
        ROW    258  
        COL    714 
        WIDTH  148  
        HEIGHT 191   
        PICTURE "Photo\00000.jpg"
        HELPID Nil
        VISIBLE .T.
        STRETCH .F.
        ACTION Nil
    END IMAGE

    DEFINE LABEL lab_photo
        ROW    230   
        COL    750 
        WIDTH  070
        HEIGHT 020
        VALUE "Photo:"
        FONTNAME "Arial"
        FONTSIZE 10
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 150,234,203 }
        FONTCOLOR NIL
    END LABEL

*---------------------------------------------------------------------*
*-----------------------------  BUTTONS ------------------------------*
*---------------------------------------------------------------------*
  
    DEFINE BUTTON  bnuevo        
        ROW    485   
        COL    055 
        WIDTH  105  
        HEIGHT 053  
        ACTION (  ANULAR_BOTO() , Apoyox_1() )     
        CAPTION "New"                    
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "New"     
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource/new.Bmp"    
        PICTALIGNMENT  LEFT
    END BUTTON

    DEFINE BUTTON Bmodificar      
        ROW    485  
        COL    185  
        WIDTH  105 
        HEIGHT 053 
        ACTION (  ANULAR_BOTO() , Apoyox_2()  )   
        CAPTION "Change"     
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Change"   
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource/Modify.bmp" 
        PICTALIGNMENT LEFT 
    END BUTTON
    
    DEFINE BUTTON buscare
        ROW    485 
        COL    315 
        WIDTH  105 
        HEIGHT 053 
        ACTION (  ANULAR_BOTO() , mIBoxZ()  )       
        CAPTION "Find"   
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Find"    
        FONTBOLD .T.
        FONTITALIC .F.              
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource/Find.bmp"
        PICTALIGNMENT LEFT 
    END BUTTON

    DEFINE BUTTON beliminar  
        ROW    485 
        COL    440 
        WIDTH  105
        HEIGHT 053 
        ACTION Eliminar() 
        CAPTION "Delete"         
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Delete"   
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource/Erase.Bmp"  
        PICTALIGNMENT LEFT 
    END BUTTON

    DEFINE BUTTON bimprime
        ROW    485 
        COL    570 
        WIDTH  105
        HEIGHT 053 
        ACTION (  ANULAR_BOTO() , mPrinting()  )   
        CAPTION "Print"   
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "List by Code"   
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource/Print.bmp"
        PICTALIGNMENT LEFT 
    END BUTTON


*---------------------------------------------------------------------*
*---------------------------- Exit -----------------------------------*
*---------------------------------------------------------------------*

    DEFINE BUTTON bsalir
        ROW    550 
        COL    734    
        WIDTH  105
        HEIGHT 053
        ACTION  FinalProgram()       
        CAPTION "Exit"   
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Exit"    
        FONTBOLD .T.
        FONTITALIC .F.              
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource/Exit.Bmp"
        PICTALIGNMENT LEFT 
    END BUTTON

*---------------------------------------------------------------------*
*---------------------------  Up-Down  -------------------------------*
*---------------------------------------------------------------------*

    DEFINE BUTTON But_01  
         ROW 495    
         COL 725             
         WIDTH 30
         HEIGHT 30 
         PICTURE "resource/01.bmp"                 
         TOOLTIP 'First'  
         ACTION ( DbGoTop() , Form_1.browse_1.value := ( ficher)->(recno())  )                        
     END BUTTON

    DEFINE BUTTON But_02 
         ROW 495   
         COL 755    
         WIDTH 30
         HEIGHT 30 
         PICTURE "resource/03.bmp"               
         TOOLTIP 'Previous'
         ACTION ( DbSkip(-1) , Form_1.browse_1.value := ( ficher)->(recno())  ) 
    END BUTTON
 
    DEFINE BUTTON But_03
         ROW 495 
         COL 785   
         WIDTH 30
         HEIGHT 30 
         PICTURE "resource/04.bmp"              
         TOOLTIP 'Next'
         ACTION ( DbSkip(1) ,if ( eof() , DbGoBottom() , Nil ) , Form_1.browse_1.value := ( ficher)->(recno()) )        
    END BUTTON   

    DEFINE BUTTON But_04
         ROW 495   
         COL 815   
         WIDTH 30
         HEIGHT 30 
         PICTURE "resource/06.bmp"                   
         TOOLTIP 'Last'  
         ACTION ( DbGoBottom() , Form_1.browse_1.value := ( ficher)->(recno()) ) 
    END BUTTON   

    DEFINE FRAME frame_01
         ROW 480   
         COL 720   
         WIDTH 130   
         HEIGHT 50
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         CAPTION "Up-Down"
         BACKCOLOR { 150,234,203 }  
         FONTCOLOR Nil
         OPAQUE .T.  
    END FRAME 
 

*---------------------------------------------------------------------*
*--------------------------- End  Up-Down  ---------------------------*
*---------------------------------------------------------------------*

  
   SETWINDOWCURSOR ( Form_1.bsalir.Handle , "resource\finger.cur")
  
   END WINDOW

   CENTER WINDOW Form_1

  Form_1.Browse_1.value := 1
  Form_1.Browse_1.Refresh

   ACTIVATE WINDOW Form_1

return nil


*------------------------------------------------------------*
 Function FinalProgram()
*------------------------------------------------------------*

 IF MsgYesNo("Do you want to finish the program ?","Atention !!!") = .T.

     Form_1.Release

    Return .T.
 EndIf



*------------------------------------------------------------*
 Function ArribAbajo()         
*------------------------------------------------------------*
     Form_1.TEXT_11.value       := Code 
     Form_1.text_22.value       := Name
     Form_1.TEXT_33.value       := Phone 
     Form_1.TEXT_44.value       := Date  
     Form_1.TEXT_55.value       := SUBSTR( Photo,7,5 ) 
     Form_1.TEXT_66.value       := Married
     Form_1.EDIT_11.value       := Notes
     Form_1.ImagePhoto.Picture  := ("Photo\"+ SUBSTR( Photo,7,5 )+".jpg")  
         
 Return 

*------------------------------------------------------------*
 Function ACTIVA_BOTO()      
*------------------------------------------------------------*
     Form_1.bnuevo.Enabled     := .T.        
     Form_1.Bmodificar.Enabled := .T.        
     Form_1.buscare.Enabled    := .T.        
     Form_1.beliminar.Enabled  := .T.        
     Form_1.bimprime.Enabled   := .T.        
     
     Form_1.But_01.Enabled     := .T.        
     Form_1.But_02.Enabled     := .T.        
     Form_1.But_03.Enabled     := .T.        
     Form_1.But_04.Enabled     := .T. 
       
     Form_1.bsalir.Enabled     := .T.          
         
 Return 

*------------------------------------------------------------*
 Function  ANULAR_BOTO()    
*------------------------------------------------------------*
     Form_1.bnuevo.Enabled     := .F.        
     Form_1.Bmodificar.Enabled := .F.        
     Form_1.buscare.Enabled    := .F.        
     Form_1.beliminar.Enabled  := .F.        
     Form_1.bimprime.Enabled   := .F.        
     
     Form_1.But_01.Enabled     := .F.        
     Form_1.But_02.Enabled     := .F.        
     Form_1.But_03.Enabled     := .F.        
     Form_1.But_04.Enabled     := .F. 
       
     Form_1.bsalir.Enabled     := .F.    
               
 Return 

*------------------------------------------------------------*
 Function CreateTable
*------------------------------------------------------------*

  IF !FILE('test2.mdb') 
        CreateNewTable()

  ELSE
   
    USE test2.mdb VIA "ADORDD" TABLE "table1" alias table1

    DELETE FOR table1->Code =  0  
  
    dbGotop()

    ArribAbajo()   

  ENDIF  

Return

*------------------------------------------------------------*
 Function CreateNewTable()
*------------------------------------------------------------*

   DbCreate( "test2.mdb;table1", { { "Code"    ,  "N",   5, 0 },;
                                   { "Name"    ,  "C",  25, 0 },;
                                   { "Phone"   ,  "C",  15, 0 },;
                                   { "Date"    ,  "C",  10, 0 },;   
                                   { "Married" ,  "C",   3, 0 },;   
                                   { "Notes"   ,  "C", 200, 0 },;   
                                   { "Photo"   ,  "C",  15, 0 } }, "ADORDD" ) 

   USE test2.mdb VIA "ADORDD" TABLE "table1" alias table1
 
   APPEND BLANK
   table1->Code    = 1            
   table1->Name    = "Sample Name"
   table1->Phone   = "0"
   table1->Date    = DTOC(DATE())            
   table1->Married = "NO"
   table1->Notes   = ""
   table1->Photo   = "Photo\"+"00000"+".jpg"         

RETURN

*------------------------------------------------------------*
 Function CloseTable
*------------------------------------------------------------*
   USE

Return

*------------------------------------------------------------*
 Function Altax()
*------------------------------------------------------------*

  IF UPPER( Form_2.Control_2.Value ) <= SPACE(1)
       msgStop('Write Full Name!','warning!')
       return
  ENDIF

   USE test2.mdb VIA "ADORDD" TABLE "table1" alias table1

   APPEND BLANK
   REPLACE table1->Code      WITH Form_2.Control_1.Value  
   REPLACE table1->Name      WITH UPPER( Form_2.Control_2.Value ) 
   REPLACE table1->Phone     WITH Form_2.Control_3.Value  
   REPLACE table1->Date      WITH Form_2.Control_4.Value         
   REPLACE table1->Married   WITH UPPER( Form_2.Control_5.Value )
   REPLACE table1->Notes     WITH Form_2.Edit_1.Value 
   REPLACE table1->Photo     WITH "Photo\"+Form_2.Control_6.value+".jpg"

   DbGoBottom() 


   Form_1.browse_1.value := ( ficher)->(recno()) 
    ArribAbajo()  
   Form_1.Browse_1.Value := RECNO()
   Form_1.Browse_1.Refresh 
 
Return

*------------------------------------------------------------------------------------------------*
*----------------------------------------  Change    --------------------------------------------*
*------------------------------------------------------------------------------------------------*

*------------------------------------------------------------*
Function Apoyox_2()
*------------------------------------------------------------*

     DEFINE WINDOW Form_2x     ;
      AT 0,0                   ;
      WIDTH  700               ;                     
      HEIGHT 320               ; 
      NOCAPTION                ;
      BACKCOLOR {137,115,183}  ; 
      TOPMOST                  ;   
      CHILD NOSIZE     
              
      ON KEY ESCAPE ACTION ( ACTIVA_BOTO() , Form_2x.Release )

*------------------------------------------------------------*

*----------------------------------------- Recuadro Ventana y Sombra -----------------------------------------*
*------------------------------    Rutina cedida por Lucho Miranda   ElSalnes@telefonica.net -----------------*
          @ 008,004 LABEL Label_02Sx WIDTH 708 HEIGHT 333 ; 
                    FONT "Ms Sans Serif" SIZE 0011 BACKCOLOR  {000,000,000}  

          @ 000,000 LABEL Label_02sz  WIDTH 698 HEIGHT 318 ;
                    FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE BACKCOLOR { 137,115,183 }  
*-------------------------------------------------------------------------------------------------------------*

         Form_2x.Label_02sx.Enabled := .F.
         Form_2x.Label_02sz.Enabled := .F.

*------------------------------------------------------------*

  DEFINE LABEL Label_0x
        ROW    020
        COL    290 
        WIDTH  200  
        HEIGHT 030
        VALUE "Change Record"
        FONTNAME "Arial"
        FONTSIZE 13
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}  
        FONTCOLOR NIL
   END LABEL

*------------------------------------------------------------*       

  DEFINE LABEL Label_1x
        ROW    047 
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Code:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183} 
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX  Control_1x
        ROW    047   
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_1x.FontBold := .T.  
        ONLOSTFOCUS Form_2x.Label_1x.FontBold := .F.  
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 5
        BACKCOLOR {253,209,209}  
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .T. 
        VALUE ""
    END TEXTBOX
		
*-----------------------------------------------------------------*

    DEFINE LABEL Label_2x
        ROW    077    
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Name:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183} 
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_2x
        ROW    077    
        COL    100
        WIDTH  310
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Name"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_2x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_2x.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 40
        BACKCOLOR  { 253,209,209 } 
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_3x
        ROW    107    
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Phone:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183} 
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_3x 
        ROW    107 
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Phone"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_3x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_3x.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.    
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 9
        BACKCOLOR { 253,209,209 }  
        FONTCOLOR NIL
        INPUTMASK '999999999'
        FORMAT Nil
        NUMERIC .F.                 
        VALUE "0"
    END TEXTBOX

*-----------------------------------------------------------------*
		
    DEFINE LABEL Label_4x
        ROW    137    
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Date:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183} 
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Control_4x 
        ROW    137 
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Date"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_4x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_4x.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 10
        BACKCOLOR {253,209,209}  
        FONTCOLOR NIL
        INPUTMASK "99/99/9999"
        FORMAT Nil
        NUMERIC .F.                 
        VALUE DTOC(DATE())
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_5x
        ROW    167 
        COL    020
        WIDTH  080
        HEIGHT 020
        VALUE "Married:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183} 
        FONTCOLOR NIL
    END LABEL 

    DEFINE TEXTBOX Control_5x
        ROW    167  
        COL    100
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Married"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_5x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_5x.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 3
        BACKCOLOR { 253,209,209 }  
        FONTCOLOR NIL
        INPUTMASK NIL
        FORMAT Nil
        NUMERIC .F.                 
        VALUE ""
    END TEXTBOX

     DEFINE LABEL LABEL_6x 
        ROW    197    
        COL    020    
        WIDTH  070
        HEIGHT 020
        VALUE "N Photo:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183} 
        FONTCOLOR NIL
    END LABEL 

    DEFINE TEXTBOX Control_6x
        ROW    197 
        COL    100 
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "N Photo"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Label_6x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Label_6x.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 10
        BACKCOLOR {253,209,209}  
        FONTCOLOR NIL
        INPUTMASK "99999" 
        FORMAT Nil
        NUMERIC .F.                 
        VALUE "00000"
    END TEXTBOX

*---------------------------------------------------------------------*
 
    DEFINE LABEL Edit1x
        ROW    047    
        COL    327 
        WIDTH  070
        HEIGHT 020
        VALUE "Notes:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {137,115,183}
        FONTCOLOR NIL
    END LABEL

    DEFINE EDITBOX Edit_1x
        ROW    047
        COL    440
        WIDTH  235 
        HEIGHT 140   
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Notes"
        ONCHANGE Nil
        ONGOTFOCUS  Form_2x.Edit1x.FontBold := .T.
        ONLOSTFOCUS Form_2x.Edit1x.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        HSCROLLBAR .T.
        VSCROLLBAR .T.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        BACKCOLOR { 253,209,209 }    
        FONTCOLOR Nil
    END EDITBOX

*---------------------------------------------------------------------*
*---------------------------------------------------------------------*

       @ 240, 235 BUTTON SAVE_EMPLx  ;
         CAPTION "&Save"             ;
         PICTURE "resource\ok.bmp"   ;
         FONT "Arial"                ;
         SIZE 9                      ;
         BOLD                        ;
         ITALIC                      ;
         ACTION ( Editax() , ACTIVA_BOTO() , Form_2x.Release() ) ;
         TOOLTIP "Save"              ;
         RIGHT                       ;
         WIDTH 100                   ;
         HEIGHT 40 

       @ 240,335 BUTTON CANCEL_EMPLx ;
         CAPTION "&Cancel"           ;
         PICTURE "resource\cancel.bmp" ;
         FONT "Arial"                ;
         SIZE 9                      ; 
         BOLD                        ;
         ITALIC                      ;
         ACTION (  ACTIVA_BOTO() , Form_2x.Release() ) ;
         TOOLTIP "Cancel"            ;
         RIGHT                       ;
         WIDTH 100                   ;
         HEIGHT 40 


*---------------------------------------------------------------------*
*---------------------------------------------------------------------*

   Contro()

   END WINDOW

   CENTER WINDOW Form_2x
   ACTIVATE WINDOW Form_2x
    
return nil  

*------------------------------------------------------------*
 Function Contro()
*------------------------------------------------------------*

    GO  Form_1.Browse_1.Value

        Form_2x.Control_1x.Value := table1->Code
        Form_2x.Control_2x.Value := table1->Name
        Form_2x.Control_3x.Value := table1->Phone 
        Form_2x.Control_4x.Value := table1->Date
        Form_2x.Control_5x.Value := table1->Married
        Form_2x.Edit_1x.Value    := table1->Notes
        Form_2x.Control_6x.Value := SUBSTR( table1->Photo,7,5 ) 

Return

*------------------------------------------------------------*
 Function Editax()
*------------------------------------------------------------*
 
    REPLACE table1->Code     WITH Form_2x.Control_1x.Value 
    REPLACE table1->Name     WITH UPPER (Form_2x.Control_2x.Value ) 
    REPLACE table1->Phone    WITH Form_2x.Control_3x.Value 
    REPLACE table1->Date     WITH Form_2x.Control_4x.Value   
    REPLACE table1->Married  WITH UPPER (Form_2x.Control_5x.Value )        
    REPLACE table1->Notes    WITH Form_2x.Edit_1x.Value 
    REPLACE table1->Photo    WITH "Photo\"+Form_2x.Control_6x.value +".jpg" 
 
    DbGoBottom() 
    Form_1.browse_1.value := ( ficher)->(recno()) 
    ArribAbajo()  
    Form_1.Browse_1.Value := RECNO()
    Form_1.Browse_1.Refresh 
  
 Return 

*------------------------------------------------------------*
 Function Eliminar()
*------------------------------------------------------------*
 
  GO  Form_1.Browse_1.Value
              
  IF MsgYesNo( "Proceed to remove the Record ?"+CRLF+CRLF+; 
                    "Code:   "+ SPACE(1) + LTRIM(STR(table1->Code)) + CRLF+ ; 
                    "Name:   "+ ALLTRIM( table1->Name ) + CRLF+ ;  
                    "Phone:  "+ SPACE(1) + LTRIM( table1->Phone ) + CRLF+ ;
                    "Date:   "+ SPACE(3) + table1->Date ,"Delete Records" )
    DELETE
    SKIP
    IF EOF()
       GO TOP
       IF BOF()
        lExistRecords := .F.       
       ENDIF
    ENDIF
    Form_1.Browse_1.Value := RECNO()
    Form_1.Browse_1.Refresh 
 ENDIF

 RETURN(Nil)

*****//      "Code:   "+ SPACE(1) + LTRIM(STR(table1->Code)) + CRLF+ ; 
*------------------------------------------------------------*
 Function SearchData()
*------------------------------------------------------------*
  
  Local Buscar , FindWar , lFound := .t.

  Buscar := Upper ( AllTrim ( Win_0x.TEXT_R8.value ) )
 
  IF Buscar <= SPACE(1)

      MsgExclamation ( 'Write!'+CRLF+"Full Name!", 'Attention!' )
      Return

  ENDIF   

  Select("table1")

  dbgotop()

  FindWar := "name = '"+Buscar+"'"

  LOCATE FOR &FindWar

  IF ! Eof()

     lFound := .t.

      Form_1.Browse_1.Value := Recno()         
      Form_1.Browse_1.SetFocus()
      Form_1.Browse_1.Refresh()

   else

     dbgotop()

      MsgExclamation ( 'No Success!'+CRLF+"Change Properties!", 'Error' )

ENDIF

 Form_1.Browse_1.SetFocus()
 Form_1.Browse_1.Refresh()

RETURN Nil


  





































