*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

#include "hmg.ch"

*------------------------------------------------------------*
Function mPrinting() 
*------------------------------------------------------------* 

DEFINE WINDOW Form_2s       ;
    AT 0,0                  ;
    WIDTH 300               ;                 
    HEIGHT 210              ;               
    NOCAPTION               ;
    BACKCOLOR {137,115,183} ; 
    TOPMOST                 ;   
    CHILD NOSIZE                  

    ON KEY ESCAPE ACTION ( ACTIVA_BOTO() , Form_2s.Release )

*------------------------------------------------------------*

*----------------------------------------- Recuadro Ventana y Sombra -----------------------------------------*
*------------------------------    Rutina cedida por Lucho Miranda   ElSalnes@telefonica.net -----------------*
          @ 008,004 LABEL Label_00Sx WIDTH 305 HEIGHT 215 ;  
                    FONT "Ms Sans Serif" SIZE 0011 BACKCOLOR  {000,000,000}  

          @ 000,000 LABEL Label_00sz  WIDTH 298 HEIGHT 208 ;
                    FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE BACKCOLOR { 137,115,183 }  //{ 087,067,129 }  
*-------------------------------------------------------------------------------------------------------------*

         Form_2s.Label_00sx.Enabled := .F.
         Form_2s.Label_00sz.Enabled := .F.

*------------------------------------------------------------*

     DEFINE FRAME frame_02
         ROW 021  
         COL 090
         WIDTH  120  
         HEIGHT 098
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         CAPTION "Printer"
         BACKCOLOR { 137,115,183 }  
         FONTCOLOR Nil
         OPAQUE .T.  
     END FRAME 

     DEFINE LABEL  Label_Print 
        ROW    038  
        COL    111  
        WIDTH  090
        HEIGHT 020
        VALUE "Printer List"
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP "Printer List"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 137,115,183 }  
        FONTCOLOR NIL
    END LABEL

    DEFINE RADIOGROUP RadioGroup_Print
        ROW    060    
        COL    111 
        WIDTH  080
        HEIGHT 050
        OPTIONS {'Printer','File Pdf'}      
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE nil    
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        SPACING 25
        BACKCOLOR { 137,115,183 } 
        FONTCOLOR NIL
        READONLY Nil
        HORIZONTAL .F. 
    END RADIOGROUP

*------------------------------------------------------------*
*------------------------------------------------------------*
  
     @ 140, 042 BUTTON But_Print   ;  
         CAPTION "&Acept"          ;
         PICTURE "resource\ok.bmp" ;
         FONT "Arial"              ;
         SIZE 9                    ;
         BOLD                      ;
         ITALIC                    ;
         ACTION ( Search_Print() , ACTIVA_BOTO() , Form_2s.Release() ) ;
         TOOLTIP "Acept"           ;
         RIGHT                     ;
         WIDTH 105                 ;
         HEIGHT 40 

      @ 140,148 BUTTON But_Cancel  ;   
         CAPTION "&Cancel"         ;
         PICTURE "resource\cancel.bmp" ;
         FONT "Arial"              ;
         SIZE 9                    ;
         BOLD                      ;
         ITALIC                    ;
         ACTION (  ACTIVA_BOTO() , Form_2s.Release() ) ;
         TOOLTIP "Cancel"          ;
         RIGHT                     ;
         WIDTH 105                 ;
         HEIGHT 40 

  END WINDOW

   CENTER WINDOW Form_2s
   ACTIVATE WINDOW Form_2s


return nil

*------------------------------------------------------------*
 Function Search_Print()
*------------------------------------------------------------*

  Private FDIA   := DTOC(DATE()) 
  Private FDIAx  := STRTRAN(FDIA, '/')    && <---  eliminas la barra(/) 
  Private HORA   := LEFT(TIME(), 5) 
  Private HORAx  := STRTRAN(HORA, ':')    && <---  eliminas los dos puntos(:) 
  Private newpdf := "backup_files\" + "file" + "_" + FDIAx + '_' + HORAx + '.pdf' 

*------------------------------------------------------------*

   DO CASE
      CASE  Form_2s.RadioGroup_Print.value = 1  

        ( CreateReport() , ExecuteReport('Report1',.T.) )
             
      CASE  Form_2s.RadioGroup_Print.value = 2  

        ( CreateReport() , ExecuteReport('Report1',.t.,.t., newpdf ) )
               
   ENDCASE

   Return Nil
*------------------------------------------------------------*
 Function CreateReport() 
*------------------------------------------------------------*

	DEFINE REPORT Report1


		* Report Layout ***********************************************

		BEGIN LAYOUT 
			PAPERSIZE	PRINTER_PAPER_A4
			ORIENTATION	PRINTER_ORIENT_PORTRAIT 
		END LAYOUT

		* Header Band *************************************************

		BEGIN HEADER

			BANDHEIGHT	25

			BEGIN LINE
				FROMROW		23
				FROMCOL		10
				TOROW		23
				TOCOL		200
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

			BEGIN TEXT
				EXPRESSION	'DataBase Adordd Photo'
				ROW		10  	
				COL		62 
				WIDTH		100	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	20	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left
			END TEXT

			BEGIN PICTURE
				VALUE		'resource\Business-Pie.jpg'           
				ROW		08   	
				COL		189	
				WIDTH		11	
				HEIGHT		11	
				STRETCH		.F.
			END PICTURE

		END HEADER

		* Detail Band *************************************************

		BEGIN DETAIL

			BANDHEIGHT	6

			BEGIN TEXT
				EXPRESSION	table1->Code 
				ROW		2	
				COL		24  
				WIDTH		10	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	RIGHT  
			END TEXT

			BEGIN TEXT
				EXPRESSION	table1->Name 
				ROW		2	
				COL		40 
				WIDTH		60
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	table1->Phone 
				ROW		2	
				COL		103  
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	table1->Married 
				ROW		2	
				COL		135  
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	table1->Date
				ROW		2	
				COL		160 
				WIDTH		60	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	9	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			
			END TEXT

		END DETAIL

		* Footer Band *************************************************

		BEGIN FOOTER

			BANDHEIGHT	27

			BEGIN LINE
				FROMROW		4
				FROMCOL		10	
				TOROW		4	
				TOCOL		200	
				PENWIDTH	0.1	
				PENCOLOR	{ 0 , 0 , 0 }	
			END LINE

			BEGIN TEXT
				EXPRESSION	'Page. No:' + Str(_PageNo)
				ROW		7	
				COL		11	
				WIDTH		100	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	Date()
				ROW		7	
				COL		177	
				WIDTH		30	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END FOOTER

		* Summary Band ************************************************

		BEGIN SUMMARY

			BANDHEIGHT	50

			BEGIN TEXT
				EXPRESSION	'Total Records: ' + Str(RecCount()) 
				ROW		10
				COL		20	
				WIDTH		100	
				HEIGHT		30
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END SUMMARY

	END REPORT

Return


*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*







